﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace SyncfusionBindingError.Entities
{
    public class PriceListGrid : Microsoft.Practices.Prism.Mvvm.BindableBase
    {

        //private readonly IEventAggregator _eventAggregator;

        public PriceListGrid(string partPricingInfo, Guid priceUID)
        {
            PartPriceAmountInfo = partPricingInfo;
            PriceUID = priceUID;

            //_eventAggregator = eventAggregator;

            this.PropertyChanged += PriceListGrid_PropertyChanged;
        }

        private void PriceListGrid_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "NewPriceString")
            {
                //replace . by , and check if the content is numeric only 
                NewPriceString = NewPriceString.Replace('.', ',');
                NewPriceString = Regex.Replace(NewPriceString, "[^0-9,]", "");
                NewPrice = Decimal.Parse(NewPriceString);

                if (NewPrice != CurrentPrice)
                {
                   // _eventAggregator.GetEvent<EditPartEvent>().Publish(this);
                }
            }
        }

        public Guid PriceUID { get; set; }
        public string PartPriceAmountInfo { get; set; }
        public byte PriceNo { get; set; }
        public string ComputedPrice { get; set; }
        public DateTime? ComputedPriceDate { get; set; }

        public decimal CurrentPrice { get; set; }

        public Decimal NewPrice { get; set; }

        private String _newPriceStringProperty;

        public String NewPriceString
        {
            get { return _newPriceStringProperty; }
            set { SetProperty(ref _newPriceStringProperty, value); }
        }

        public string ColorIfForced { get; set; }

        public byte ForcedFlag { get; set; }

        public string PriceNoAndName { get; set; }
    }

}
